diff -crBPN --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=1.html --exclude=2.html --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.7.pl /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-admin/includes/dashboard.php /home/packages/code/qi/SOURCES/wordpress-3.7/wp-admin/includes/dashboard.php
*** /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-admin/includes/dashboard.php	2013-05-22 16:01:57.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.7/wp-admin/includes/dashboard.php	2013-10-22 12:22:11.000000000 -0500
***************
*** 142,152 ****
  	if ( $update )
  		update_option( 'dashboard_widget_options', $widget_options );
  
  	do_action('do_meta_boxes', $screen->id, 'normal', '');
  	do_action('do_meta_boxes', $screen->id, 'side', '');
  }
  
! function wp_add_dashboard_widget( $widget_id, $widget_name, $callback, $control_callback = null ) {
  	$screen = get_current_screen();
  	global $wp_dashboard_control_callbacks;
  
--- 142,154 ----
  	if ( $update )
  		update_option( 'dashboard_widget_options', $widget_options );
  
+ 	/** This action is documented in wp-admin/edit-form-advanced.php */
  	do_action('do_meta_boxes', $screen->id, 'normal', '');
+ 	/** This action is documented in wp-admin/edit-form-advanced.php */
  	do_action('do_meta_boxes', $screen->id, 'side', '');
  }
  
! function wp_add_dashboard_widget( $widget_id, $widget_name, $callback, $control_callback = null, $callback_args = null ) {
  	$screen = get_current_screen();
  	global $wp_dashboard_control_callbacks;
  
***************
*** 177,183 ****
  	if ( 'dashboard_browser_nag' === $widget_id )
  		$priority = 'high';
  
! 	add_meta_box( $widget_id, $widget_name, $callback, $screen, $location, $priority );
  }
  
  function _wp_dashboard_control_callback( $dashboard, $meta_box ) {
--- 179,185 ----
  	if ( 'dashboard_browser_nag' === $widget_id )
  		$priority = 'high';
  
! 	add_meta_box( $widget_id, $widget_name, $callback, $screen, $location, $priority, $callback_args );
  }
  
  function _wp_dashboard_control_callback( $dashboard, $meta_box ) {
***************
*** 366,372 ****
  
  	if ( $theme->errors() ) {
  		if ( ! is_multisite() || is_super_admin() )
! 			echo '<span class="error-message">' . __('ERROR: The themes directory is either empty or doesn&#8217;t exist. Please check your installation.') . '</span>';
  	} elseif ( ! empty($wp_registered_sidebars) ) {
  		$sidebars_widgets = wp_get_sidebars_widgets();
  		$num_widgets = 0;
--- 368,374 ----
  
  	if ( $theme->errors() ) {
  		if ( ! is_multisite() || is_super_admin() )
! 			echo '<span class="error-message">' . sprintf( __( 'ERROR: %s' ), $theme->errors()->get_error_message() ) . '</span>';
  	} elseif ( ! empty($wp_registered_sidebars) ) {
  		$sidebars_widgets = wp_get_sidebars_widgets();
  		$num_widgets = 0;
***************
*** 710,716 ****
  		<div id="comment-<?php echo $comment->comment_ID; ?>" <?php comment_class( array( 'comment-item', wp_get_comment_status($comment->comment_ID) ) ); ?>>
  			<?php if ( !$comment->comment_type || 'comment' == $comment->comment_type ) : ?>
  
! 			<?php echo get_avatar( $comment, 50 ); ?>
  
  			<div class="dashboard-comment-wrap">
  			<h4 class="comment-meta">
--- 712,718 ----
  		<div id="comment-<?php echo $comment->comment_ID; ?>" <?php comment_class( array( 'comment-item', wp_get_comment_status($comment->comment_ID) ) ); ?>>
  			<?php if ( !$comment->comment_type || 'comment' == $comment->comment_type ) : ?>
  
! 			<?php echo get_avatar( $comment, 50, 'mystery' ); ?>
  
  			<div class="dashboard-comment-wrap">
  			<h4 class="comment-meta">
***************
*** 1095,1100 ****
--- 1097,1103 ----
  	if ( 'POST' == $_SERVER['REQUEST_METHOD'] && isset($_POST['widget-rss'][$number]) ) {
  		$_POST['widget-rss'][$number] = wp_unslash( $_POST['widget-rss'][$number] );
  		$widget_options[$widget_id] = wp_widget_rss_process( $_POST['widget-rss'][$number] );
+ 		$widget_options[$widget_id]['number'] = $number;
  		// title is optional. If black, fill it if possible
  		if ( !$widget_options[$widget_id]['title'] && isset($_POST['widget-rss'][$number]['title']) ) {
  			$rss = fetch_feed($widget_options[$widget_id]['url']);
***************
*** 1225,1231 ****
  			'user-agent'	=> 'WordPress/' . $wp_version . '; ' . home_url()
  		);
  
! 		$response = wp_remote_post( 'http://api.wordpress.org/core/browse-happy/1.0/', $options );
  
  		if ( is_wp_error( $response ) || 200 != wp_remote_retrieve_response_code( $response ) )
  			return false;
--- 1228,1234 ----
  			'user-agent'	=> 'WordPress/' . $wp_version . '; ' . home_url()
  		);
  
! 		$response = wp_remote_post( 'http://api.wordpress.org/core/browse-happy/1.1/', $options );
  
  		if ( is_wp_error( $response ) || 200 != wp_remote_retrieve_response_code( $response ) )
  			return false;
***************
*** 1241,1247 ****
  		 *  'img_src' - string - An image representing the browser
  		 *  'img_src_ssl' - string - An image (over SSL) representing the browser
  		 */
! 		$response = maybe_unserialize( wp_remote_retrieve_body( $response ) );
  
  		if ( ! is_array( $response ) )
  			return false;
--- 1244,1250 ----
  		 *  'img_src' - string - An image representing the browser
  		 *  'img_src_ssl' - string - An image (over SSL) representing the browser
  		 */
! 		$response = json_decode( wp_remote_retrieve_body( $response ), true );
  
  		if ( ! is_array( $response ) )
  			return false;
diff -crBPN --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=1.html --exclude=2.html --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.7.pl /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-admin/includes/deprecated.php /home/packages/code/qi/SOURCES/wordpress-3.7/wp-admin/includes/deprecated.php
*** /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-admin/includes/deprecated.php	2013-03-01 11:57:49.000000000 -0600
--- /home/packages/code/qi/SOURCES/wordpress-3.7/wp-admin/includes/deprecated.php	2013-10-23 09:40:10.000000000 -0500
***************
*** 13,20 ****
   */
  
  /**
!  * @since 2.1
!  * @deprecated 2.1
   * @deprecated Use wp_editor().
   * @see wp_editor()
   */
--- 13,20 ----
   */
  
  /**
!  * @since 2.1.0
!  * @deprecated 2.1.0
   * @deprecated Use wp_editor().
   * @see wp_editor()
   */
***************
*** 27,34 ****
  /**
   * Unused Admin function.
   *
!  * @since 2.0
!  * @deprecated 2.5
   *
   */
  function documentation_link() {
--- 27,34 ----
  /**
   * Unused Admin function.
   *
!  * @since 2.0.0
!  * @deprecated 2.5.0
   *
   */
  function documentation_link() {
***************
*** 107,112 ****
--- 107,128 ----
  }
  
  /**
+  * Get the real filesystem path to a file to edit within the admin.
+  *
+  * @since 1.5.0
+  * @deprecated 2.9.0
+  * @uses WP_CONTENT_DIR Full filesystem path to the wp-content directory.
+  *
+  * @param string $file Filesystem path relative to the wp-content directory.
+  * @return string Full filesystem path to edit.
+  */
+ function get_real_file_to_edit( $file ) {
+ 	_deprecated_function( __FUNCTION__, '2.9' );
+ 
+ 	return WP_CONTENT_DIR . $file;
+ }
+ 
+ /**
   * {@internal Missing Short Description}}
   *
   * @since 1.2.0
***************
*** 207,213 ****
  /**
   * Determine whether to use CodePress.
   *
!  * @since 2.8
   * @deprecated 3.0.0
  **/
  function use_codepress() {
--- 223,229 ----
  /**
   * Determine whether to use CodePress.
   *
!  * @since 2.8.0
   * @deprecated 3.0.0
  **/
  function use_codepress() {
***************
*** 719,725 ****
  
  /**
   * @since 2.7.0
!  * @deprecated 3.3
   * @deprecated Use wp_editor()
   * @see wp_editor()
   */
--- 735,741 ----
  
  /**
   * @since 2.7.0
!  * @deprecated 3.3.0
   * @deprecated Use wp_editor()
   * @see wp_editor()
   */
***************
*** 924,929 ****
--- 940,946 ----
   * {@internal Missing Short Description}}
   *
   * @since 1.5.0
+  * @deprecated 3.4.0
   *
   * @return unknown
   */
***************
*** 947,952 ****
--- 964,970 ----
   * {@internal Missing Short Description}}
   *
   * @since 2.0.0
+  * @deprecated 3.4.0
   *
   * @return unknown
   */
***************
*** 1023,1025 ****
--- 1041,1133 ----
  	_deprecated_function( __FUNCTION__, '3.5', 'image_resize()' );
  	return apply_filters( 'wp_create_thumbnail', image_resize( $file, $max_side, $max_side ) );
  }
+ 
+ /**
+  * This was once used to display a metabox for the nav menu theme locations.
+  *
+  * Deprecated in favor of a 'Manage Locations' tab added to nav menus management screen.
+  *
+  * @since 3.0.0
+  * @deprecated 3.6.0
+  */
+ function wp_nav_menu_locations_meta_box() {
+ 	_deprecated_function( __FUNCTION__, '3.6' );
+ }
+ 
+ /**
+  * This was once used to kick-off the Core Updater.
+  *
+  * Deprecated in favor of instantating a Core_Upgrader instance directly,
+  * and calling the 'upgrade' method.
+  *
+  * @since 2.7.0
+  * @deprecated 3.7.0
+  */
+ function wp_update_core($current, $feedback = '') {
+ 	_deprecated_function( __FUNCTION__, '3.7', 'new Core_Upgrader();' );
+ 
+ 	if ( !empty($feedback) )
+ 		add_filter('update_feedback', $feedback);
+ 
+ 	include ABSPATH . 'wp-admin/includes/class-wp-upgrader.php';
+ 	$upgrader = new Core_Upgrader();
+ 	return $upgrader->upgrade($current);
+ 
+ }
+ 
+ /**
+  * This was once used to kick-off the Plugin Updater.
+  *
+  * Deprecated in favor of instantating a Plugin_Upgrader instance directly,
+  * and calling the 'upgrade' method.
+  * Unused since 2.8.0.
+  *
+  * @since 2.5.0
+  * @deprecated 3.7.0
+  */
+ function wp_update_plugin($plugin, $feedback = '') {
+ 	_deprecated_function( __FUNCTION__, '3.7', 'new Plugin_Upgrader();' );
+ 
+ 	if ( !empty($feedback) )
+ 		add_filter('update_feedback', $feedback);
+ 
+ 	include ABSPATH . 'wp-admin/includes/class-wp-upgrader.php';
+ 	$upgrader = new Plugin_Upgrader();
+ 	return $upgrader->upgrade($plugin);
+ }
+ 
+ /**
+  * This was once used to kick-off the Plugin Updater.
+  *
+  * Deprecated in favor of instantating a Plugin_Upgrader instance directly,
+  * and calling the 'upgrade' method.
+  * Unused since 2.8.0.
+  *
+  * @since 2.7.0
+  * @deprecated 3.7.0
+  */
+ function wp_update_theme($theme, $feedback = '') {
+ 	_deprecated_function( __FUNCTION__, '3.7', 'new Theme_Upgrader();' );
+ 
+ 	if ( !empty($feedback) )
+ 		add_filter('update_feedback', $feedback);
+ 
+ 	include ABSPATH . 'wp-admin/includes/class-wp-upgrader.php';
+ 	$upgrader = new Theme_Upgrader();
+ 	return $upgrader->upgrade($theme);
+ }
+ 
+ /**
+  * This was once used to display attachment links. Now it is deprecated and stubbed.
+  *
+  * {@internal Missing Short Description}}
+  *
+  * @since 2.0.0
+  * @deprecated 3.7.0
+  *
+  * @param unknown_type $id
+  * @return unknown
+  */
+ function the_attachment_links( $id = false ) {
+ 	_deprecated_function( __FUNCTION__, '3.7' );
+ }
diff -crBPN --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=1.html --exclude=2.html --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.7.pl /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-admin/includes/export.php /home/packages/code/qi/SOURCES/wordpress-3.7/wp-admin/includes/export.php
*** /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-admin/includes/export.php	2013-03-01 10:27:03.000000000 -0600
--- /home/packages/code/qi/SOURCES/wordpress-3.7/wp-admin/includes/export.php	2013-10-22 12:22:11.000000000 -0500
***************
*** 367,376 ****
  		$is_sticky = is_sticky( $post->ID ) ? 1 : 0;
  ?>
  	<item>
  		<title><?php echo apply_filters( 'the_title_rss', $post->post_title ); ?></title>
  		<link><?php the_permalink_rss() ?></link>
  		<pubDate><?php echo mysql2date( 'D, d M Y H:i:s +0000', get_post_time( 'Y-m-d H:i:s', true ), false ); ?></pubDate>
! 		<dc:creator><?php echo get_the_author_meta( 'login' ); ?></dc:creator>
  		<guid isPermaLink="false"><?php the_guid(); ?></guid>
  		<description></description>
  		<content:encoded><?php echo wxr_cdata( apply_filters( 'the_content_export', $post->post_content ) ); ?></content:encoded>
--- 367,377 ----
  		$is_sticky = is_sticky( $post->ID ) ? 1 : 0;
  ?>
  	<item>
+ 		<?php /** This filter is documented in wp-includes/feed.php */ ?>
  		<title><?php echo apply_filters( 'the_title_rss', $post->post_title ); ?></title>
  		<link><?php the_permalink_rss() ?></link>
  		<pubDate><?php echo mysql2date( 'D, d M Y H:i:s +0000', get_post_time( 'Y-m-d H:i:s', true ), false ); ?></pubDate>
! 		<dc:creator><?php echo wxr_cdata( get_the_author_meta( 'login' ) ); ?></dc:creator>
  		<guid isPermaLink="false"><?php the_guid(); ?></guid>
  		<description></description>
  		<content:encoded><?php echo wxr_cdata( apply_filters( 'the_content_export', $post->post_content ) ); ?></content:encoded>
diff -crBPN --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=1.html --exclude=2.html --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.7.pl /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-admin/includes/file.php /home/packages/code/qi/SOURCES/wordpress-3.7/wp-admin/includes/file.php
*** /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-admin/includes/file.php	2013-07-31 01:53:06.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.7/wp-admin/includes/file.php	2013-10-22 13:18:09.000000000 -0500
***************
*** 94,123 ****
  }
  
  /**
-  * Get the real file system path to a file to edit within the admin
-  *
-  * If the $file is index.php or .htaccess this function will assume it is relative
-  * to the install root, otherwise it is assumed the file is relative to the wp-content
-  * directory
-  *
-  * @since 1.5.0
-  *
-  * @uses get_home_path
-  * @uses WP_CONTENT_DIR full filesystem path to the wp-content directory
-  * @param string $file filesystem path relative to the WordPress install directory or to the wp-content directory
-  * @return string full file system path to edit
-  */
- function get_real_file_to_edit( $file ) {
- 	if ('index.php' == $file || '.htaccess' == $file ) {
- 		$real_file = get_home_path() . $file;
- 	} else {
- 		$real_file = WP_CONTENT_DIR . $file;
- 	}
- 
- 	return $real_file;
- }
- 
- /**
   * Returns a listing of all files in the specified folder and all subdirectories up to 100 levels deep.
   * The depth of the recursiveness can be controlled by the $levels param.
   *
--- 94,99 ----
***************
*** 509,518 ****
--- 485,528 ----
  		return new WP_Error( 'http_404', trim( wp_remote_retrieve_response_message( $response ) ) );
  	}
  
+ 	$content_md5 = wp_remote_retrieve_header( $response, 'content-md5' );
+ 	if ( $content_md5 ) {
+ 		$md5_check = verify_file_md5( $tmpfname, $content_md5 );
+ 		if ( is_wp_error( $md5_check ) ) {
+ 			unlink( $tmpfname );
+ 			return $md5_check;
+ 		}
+ 	}
+ 
  	return $tmpfname;
  }
  
  /**
+  * Calculates and compares the MD5 of a file to it's expected value.
+  *
+  * @since 3.7.0
+  *
+  * @param string $filename The filename to check the MD5 of.
+  * @param string $expected_md5 The expected MD5 of the file, either a base64 encoded raw md5, or a hex-encoded md5
+  * @return bool|object WP_Error on failure, true on success, false when the MD5 format is unknown/unexpected
+  */
+ function verify_file_md5( $filename, $expected_md5 ) {
+ 	if ( 32 == strlen( $expected_md5 ) )
+ 		$expected_raw_md5 = pack( 'H*', $expected_md5 );
+ 	elseif ( 24 == strlen( $expected_md5 ) )
+ 		$expected_raw_md5 = base64_decode( $expected_md5 );
+ 	else
+ 		return false; // unknown format
+ 
+ 	$file_md5 = md5_file( $filename, true );
+ 
+ 	if ( $file_md5 === $expected_raw_md5 )
+ 		return true;
+ 
+ 	return new WP_Error( 'md5_mismatch', sprintf( __( 'The checksum of the file (%1$s) does not match the expected checksum value (%2$s).' ), bin2hex( $file_md5 ), bin2hex( $expected_raw_md5 ) ) );
+ }
+ 
+ /**
   * Unzips a specified ZIP file to a location on the Filesystem via the WordPress Filesystem Abstraction.
   * Assumes that WP_Filesystem() has already been called and set up. Does not extract a root-level __MACOSX directory, if present.
   *
***************
*** 586,609 ****
  
  	$z = new ZipArchive();
  
! 	// PHP4-compat - php4 classes can't contain constants
! 	$zopen = $z->open($file, /* ZIPARCHIVE::CHECKCONS */ 4);
  	if ( true !== $zopen )
! 		return new WP_Error('incompatible_archive', __('Incompatible Archive.'));
  
  	for ( $i = 0; $i < $z->numFiles; $i++ ) {
  		if ( ! $info = $z->statIndex($i) )
! 			return new WP_Error('stat_failed', __('Could not retrieve file from archive.'));
  
  		if ( '__MACOSX/' === substr($info['name'], 0, 9) ) // Skip the OS X-created __MACOSX directory
  			continue;
  
  		if ( '/' == substr($info['name'], -1) ) // directory
  			$needed_dirs[] = $to . untrailingslashit($info['name']);
  		else
  			$needed_dirs[] = $to . untrailingslashit(dirname($info['name']));
  	}
  
  	$needed_dirs = array_unique($needed_dirs);
  	foreach ( $needed_dirs as $dir ) {
  		// Check the parent folders of the folders all exist within the creation array.
--- 596,633 ----
  
  	$z = new ZipArchive();
  
! 	$zopen = $z->open( $file, ZIPARCHIVE::CHECKCONS );
  	if ( true !== $zopen )
! 		return new WP_Error( 'incompatible_archive', __( 'Incompatible Archive.' ), array( 'ziparchive_error' => $zopen ) );
! 
! 	$uncompressed_size = 0;
  
  	for ( $i = 0; $i < $z->numFiles; $i++ ) {
  		if ( ! $info = $z->statIndex($i) )
! 			return new WP_Error( 'stat_failed_ziparchive', __( 'Could not retrieve file from archive.' ) );
  
  		if ( '__MACOSX/' === substr($info['name'], 0, 9) ) // Skip the OS X-created __MACOSX directory
  			continue;
  
+ 		$uncompressed_size += $info['size'];
+ 
  		if ( '/' == substr($info['name'], -1) ) // directory
  			$needed_dirs[] = $to . untrailingslashit($info['name']);
  		else
  			$needed_dirs[] = $to . untrailingslashit(dirname($info['name']));
  	}
  
+ 	/*
+ 	 * disk_free_space() could return false. Assume that any falsey value is an error.
+ 	 * A disk that has zero free bytes has bigger problems.
+ 	 * Require we have enough space to unzip the file and copy its contents, with a 10% buffer.
+ 	 */
+ 	if ( defined( 'DOING_CRON' ) && DOING_CRON ) {
+ 		$available_space = @disk_free_space( WP_CONTENT_DIR );
+ 		if ( $available_space && ( $uncompressed_size * 2.1 ) > $available_space )
+ 			return new WP_Error( 'disk_full_unzip_file', __( 'Could not copy files. You may have run out of disk space.' ), compact( 'uncompressed_size', 'available_space' ) );
+ 	}
+ 
  	$needed_dirs = array_unique($needed_dirs);
  	foreach ( $needed_dirs as $dir ) {
  		// Check the parent folders of the folders all exist within the creation array.
***************
*** 623,635 ****
  	// Create those directories if need be:
  	foreach ( $needed_dirs as $_dir ) {
  		if ( ! $wp_filesystem->mkdir($_dir, FS_CHMOD_DIR) && ! $wp_filesystem->is_dir($_dir) ) // Only check to see if the Dir exists upon creation failure. Less I/O this way.
! 			return new WP_Error('mkdir_failed', __('Could not create directory.'), $_dir);
  	}
  	unset($needed_dirs);
  
  	for ( $i = 0; $i < $z->numFiles; $i++ ) {
  		if ( ! $info = $z->statIndex($i) )
! 			return new WP_Error('stat_failed', __('Could not retrieve file from archive.'));
  
  		if ( '/' == substr($info['name'], -1) ) // directory
  			continue;
--- 647,659 ----
  	// Create those directories if need be:
  	foreach ( $needed_dirs as $_dir ) {
  		if ( ! $wp_filesystem->mkdir($_dir, FS_CHMOD_DIR) && ! $wp_filesystem->is_dir($_dir) ) // Only check to see if the Dir exists upon creation failure. Less I/O this way.
! 			return new WP_Error( 'mkdir_failed_ziparchive', __( 'Could not create directory.' ), substr( $_dir, strlen( $to ) ) );
  	}
  	unset($needed_dirs);
  
  	for ( $i = 0; $i < $z->numFiles; $i++ ) {
  		if ( ! $info = $z->statIndex($i) )
! 			return new WP_Error( 'stat_failed_ziparchive', __( 'Could not retrieve file from archive.' ) );
  
  		if ( '/' == substr($info['name'], -1) ) // directory
  			continue;
***************
*** 639,648 ****
  
  		$contents = $z->getFromIndex($i);
  		if ( false === $contents )
! 			return new WP_Error('extract_failed', __('Could not extract file from archive.'), $info['name']);
  
  		if ( ! $wp_filesystem->put_contents( $to . $info['name'], $contents, FS_CHMOD_FILE) )
! 			return new WP_Error('copy_failed', __('Could not copy file.'), $to . $info['name']);
  	}
  
  	$z->close();
--- 663,672 ----
  
  		$contents = $z->getFromIndex($i);
  		if ( false === $contents )
! 			return new WP_Error( 'extract_failed_ziparchive', __( 'Could not extract file from archive.' ), $info['name'] );
  
  		if ( ! $wp_filesystem->put_contents( $to . $info['name'], $contents, FS_CHMOD_FILE) )
! 			return new WP_Error( 'copy_failed_ziparchive', __( 'Could not copy file.' ), $info['name'] );
  	}
  
  	$z->close();
***************
*** 666,676 ****
  function _unzip_file_pclzip($file, $to, $needed_dirs = array()) {
  	global $wp_filesystem;
  
! 	// See #15789 - PclZip uses string functions on binary data, If it's overloaded with Multibyte safe functions the results are incorrect.
! 	if ( ini_get('mbstring.func_overload') && function_exists('mb_internal_encoding') ) {
! 		$previous_encoding = mb_internal_encoding();
! 		mb_internal_encoding('ISO-8859-1');
! 	}
  
  	require_once(ABSPATH . 'wp-admin/includes/class-pclzip.php');
  
--- 690,696 ----
  function _unzip_file_pclzip($file, $to, $needed_dirs = array()) {
  	global $wp_filesystem;
  
! 	mbstring_binary_safe_encoding();
  
  	require_once(ABSPATH . 'wp-admin/includes/class-pclzip.php');
  
***************
*** 678,701 ****
  
  	$archive_files = $archive->extract(PCLZIP_OPT_EXTRACT_AS_STRING);
  
! 	if ( isset($previous_encoding) )
! 		mb_internal_encoding($previous_encoding);
  
  	// Is the archive valid?
  	if ( !is_array($archive_files) )
  		return new WP_Error('incompatible_archive', __('Incompatible Archive.'), $archive->errorInfo(true));
  
  	if ( 0 == count($archive_files) )
! 		return new WP_Error('empty_archive', __('Empty archive.'));
  
  	// Determine any children directories needed (From within the archive)
  	foreach ( $archive_files as $file ) {
  		if ( '__MACOSX/' === substr($file['filename'], 0, 9) ) // Skip the OS X-created __MACOSX directory
  			continue;
  
  		$needed_dirs[] = $to . untrailingslashit( $file['folder'] ? $file['filename'] : dirname($file['filename']) );
  	}
  
  	$needed_dirs = array_unique($needed_dirs);
  	foreach ( $needed_dirs as $dir ) {
  		// Check the parent folders of the folders all exist within the creation array.
--- 698,735 ----
  
  	$archive_files = $archive->extract(PCLZIP_OPT_EXTRACT_AS_STRING);
  
! 	reset_mbstring_encoding();
  
  	// Is the archive valid?
  	if ( !is_array($archive_files) )
  		return new WP_Error('incompatible_archive', __('Incompatible Archive.'), $archive->errorInfo(true));
  
  	if ( 0 == count($archive_files) )
! 		return new WP_Error( 'empty_archive_pclzip', __( 'Empty archive.' ) );
! 
! 	$uncompressed_size = 0;
  
  	// Determine any children directories needed (From within the archive)
  	foreach ( $archive_files as $file ) {
  		if ( '__MACOSX/' === substr($file['filename'], 0, 9) ) // Skip the OS X-created __MACOSX directory
  			continue;
  
+ 		$uncompressed_size += $file['size'];
+ 
  		$needed_dirs[] = $to . untrailingslashit( $file['folder'] ? $file['filename'] : dirname($file['filename']) );
  	}
  
+ 	/*
+ 	 * disk_free_space() could return false. Assume that any falsey value is an error.
+ 	 * A disk that has zero free bytes has bigger problems.
+ 	 * Require we have enough space to unzip the file and copy its contents, with a 10% buffer.
+ 	 */
+ 	if ( defined( 'DOING_CRON' ) && DOING_CRON ) {
+ 		$available_space = @disk_free_space( WP_CONTENT_DIR );
+ 		if ( $available_space && ( $uncompressed_size * 2.1 ) > $available_space )
+ 			return new WP_Error( 'disk_full_unzip_file', __( 'Could not copy files. You may have run out of disk space.' ), compact( 'uncompressed_size', 'available_space' ) );
+ 	}
+ 
  	$needed_dirs = array_unique($needed_dirs);
  	foreach ( $needed_dirs as $dir ) {
  		// Check the parent folders of the folders all exist within the creation array.
***************
*** 714,721 ****
  
  	// Create those directories if need be:
  	foreach ( $needed_dirs as $_dir ) {
! 		if ( ! $wp_filesystem->mkdir($_dir, FS_CHMOD_DIR) && ! $wp_filesystem->is_dir($_dir) ) // Only check to see if the dir exists upon creation failure. Less I/O this way.
! 			return new WP_Error('mkdir_failed', __('Could not create directory.'), $_dir);
  	}
  	unset($needed_dirs);
  
--- 748,756 ----
  
  	// Create those directories if need be:
  	foreach ( $needed_dirs as $_dir ) {
! 		// Only check to see if the dir exists upon creation failure. Less I/O this way.
! 		if ( ! $wp_filesystem->mkdir( $_dir, FS_CHMOD_DIR ) && ! $wp_filesystem->is_dir( $_dir ) )
! 			return new WP_Error( 'mkdir_failed_pclzip', __( 'Could not create directory.' ), substr( $_dir, strlen( $to ) ) );
  	}
  	unset($needed_dirs);
  
***************
*** 728,734 ****
  			continue;
  
  		if ( ! $wp_filesystem->put_contents( $to . $file['filename'], $file['content'], FS_CHMOD_FILE) )
! 			return new WP_Error('copy_failed', __('Could not copy file.'), $to . $file['filename']);
  	}
  	return true;
  }
--- 763,769 ----
  			continue;
  
  		if ( ! $wp_filesystem->put_contents( $to . $file['filename'], $file['content'], FS_CHMOD_FILE) )
! 			return new WP_Error( 'copy_failed_pclzip', __( 'Could not copy file.' ), $file['filename'] );
  	}
  	return true;
  }
***************
*** 752,782 ****
  	$from = trailingslashit($from);
  	$to = trailingslashit($to);
  
- 	$skip_regex = '';
- 	foreach ( (array)$skip_list as $key => $skip_file )
- 		$skip_regex .= preg_quote($skip_file, '!') . '|';
- 
- 	if ( !empty($skip_regex) )
- 		$skip_regex = '!(' . rtrim($skip_regex, '|') . ')$!i';
- 
  	foreach ( (array) $dirlist as $filename => $fileinfo ) {
! 		if ( !empty($skip_regex) )
! 			if ( preg_match($skip_regex, $from . $filename) )
! 				continue;
  
  		if ( 'f' == $fileinfo['type'] ) {
  			if ( ! $wp_filesystem->copy($from . $filename, $to . $filename, true, FS_CHMOD_FILE) ) {
  				// If copy failed, chmod file to 0644 and try again.
! 				$wp_filesystem->chmod($to . $filename, 0644);
  				if ( ! $wp_filesystem->copy($from . $filename, $to . $filename, true, FS_CHMOD_FILE) )
! 					return new WP_Error('copy_failed', __('Could not copy file.'), $to . $filename);
  			}
  		} elseif ( 'd' == $fileinfo['type'] ) {
  			if ( !$wp_filesystem->is_dir($to . $filename) ) {
  				if ( !$wp_filesystem->mkdir($to . $filename, FS_CHMOD_DIR) )
! 					return new WP_Error('mkdir_failed', __('Could not create directory.'), $to . $filename);
  			}
! 			$result = copy_dir($from . $filename, $to . $filename, $skip_list);
  			if ( is_wp_error($result) )
  				return $result;
  		}
--- 787,817 ----
  	$from = trailingslashit($from);
  	$to = trailingslashit($to);
  
  	foreach ( (array) $dirlist as $filename => $fileinfo ) {
! 		if ( in_array( $filename, $skip_list ) )
! 			continue;
  
  		if ( 'f' == $fileinfo['type'] ) {
  			if ( ! $wp_filesystem->copy($from . $filename, $to . $filename, true, FS_CHMOD_FILE) ) {
  				// If copy failed, chmod file to 0644 and try again.
! 				$wp_filesystem->chmod( $to . $filename, FS_CHMOD_FILE );
  				if ( ! $wp_filesystem->copy($from . $filename, $to . $filename, true, FS_CHMOD_FILE) )
! 					return new WP_Error( 'copy_failed_copy_dir', __( 'Could not copy file.' ), $to . $filename );
  			}
  		} elseif ( 'd' == $fileinfo['type'] ) {
  			if ( !$wp_filesystem->is_dir($to . $filename) ) {
  				if ( !$wp_filesystem->mkdir($to . $filename, FS_CHMOD_DIR) )
! 					return new WP_Error( 'mkdir_failed_copy_dir', __( 'Could not create directory.' ), $to . $filename );
  			}
! 
! 			// generate the $sub_skip_list for the subdirectory as a sub-set of the existing $skip_list
! 			$sub_skip_list = array();
! 			foreach ( $skip_list as $skip_item ) {
! 				if ( 0 === strpos( $skip_item, $filename . '/' ) )
! 					$sub_skip_list[] = preg_replace( '!^' . preg_quote( $filename, '!' ) . '/!i', '', $skip_item );
! 			}
! 
! 			$result = copy_dir($from . $filename, $to . $filename, $sub_skip_list);
  			if ( is_wp_error($result) )
  				return $result;
  		}
***************
*** 831,839 ****
  
  	// Set the permission constants if not already set.
  	if ( ! defined('FS_CHMOD_DIR') )
! 		define('FS_CHMOD_DIR', 0755 );
  	if ( ! defined('FS_CHMOD_FILE') )
! 		define('FS_CHMOD_FILE', 0644 );
  
  	return true;
  }
--- 866,874 ----
  
  	// Set the permission constants if not already set.
  	if ( ! defined('FS_CHMOD_DIR') )
! 		define('FS_CHMOD_DIR', ( fileperms( ABSPATH ) & 0777 | 0755 ) );
  	if ( ! defined('FS_CHMOD_FILE') )
! 		define('FS_CHMOD_FILE', ( fileperms( ABSPATH . 'index.php' ) & 0777 | 0644 ) );
  
  	return true;
  }
***************
*** 860,865 ****
--- 895,905 ----
  	if ( ! $method && function_exists('getmyuid') && function_exists('fileowner') ){
  		if ( !$context )
  			$context = WP_CONTENT_DIR;
+ 
+ 		// If the directory doesn't exist (wp-content/languages) then use the parent directory as we'll create it.
+ 		if ( WP_LANG_DIR == $context && ! is_dir( $context ) )
+ 			$context = dirname( $context );
+ 
  		$context = trailingslashit($context);
  		$temp_file_name = $context . 'temp-write-test-' . time();
  		$temp_handle = @fopen($temp_file_name, 'w');
***************
*** 990,998 ****
  -->
  </script>
  <form action="<?php echo esc_url( $form_post ) ?>" method="post">
! <div class="wrap">
! <?php screen_icon(); ?>
! <h2><?php _e('Connection Information') ?></h2>
  <p><?php
  	$label_user = __('Username');
  	$label_pass = __('Password');
--- 1030,1037 ----
  -->
  </script>
  <form action="<?php echo esc_url( $form_post ) ?>" method="post">
! <div>
! <h3><?php _e('Connection Information') ?></h3>
  <p><?php
  	$label_user = __('Username');
  	$label_pass = __('Password');
***************
*** 1025,1031 ****
  
  <tr valign="top">
  <th scope="row"><label for="password"><?php echo $label_pass; ?></label></th>
! <td><input name="password" type="password" id="password" value="<?php if ( defined('FTP_PASS') ) echo '*****'; ?>"<?php disabled( defined('FTP_PASS') ); ?> size="40" /></td>
  </tr>
  
  <?php if ( isset($types['ssh']) ) : ?>
--- 1064,1071 ----
  
  <tr valign="top">
  <th scope="row"><label for="password"><?php echo $label_pass; ?></label></th>
! <td><div><input name="password" type="password" id="password" value="<?php if ( defined('FTP_PASS') ) echo '*****'; ?>"<?php disabled( defined('FTP_PASS') ); ?> size="40" /></div>
! <div><em><?php if ( ! defined('FTP_PASS') ) _e( 'This password will not be stored on the server.' ); ?></em></div></td>
  </tr>
  
  <?php if ( isset($types['ssh']) ) : ?>
